#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "btree.h"

#define PRINT_HELP printf("Uso: %s <numero di nodi>\n", argv[0]);
#define MAX_VALUE 99

/* Ritorna un numero tra 1 e max */
#define RAND(max) (1 + (int) ((max) * (rand() / (RAND_MAX + 1.0))))

int main(int argc, char **argv) {
  struct node *btree;
  int i, n;

  if (argc == 2) {
	
	n = atoi(argv[1]);
	if (n <= 0) {
	  PRINT_HELP;
	  return 1;
	}

	/* Setta il seme */
	srand((unsigned int) time(NULL));

	/* Crea l'albero */
	btree = NULL;
	for (i = 0; i < n; i++) {
	  btree = btree_insert(btree, RAND(MAX_VALUE));
	}

	btree_depth_visit(btree);
	btree_dispose(btree);

	return 0;
  }

  PRINT_HELP;
  return 1;
}
